/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package minetweaker.mc1112.actions;

import minetweaker.IUndoableAction;
import net.minecraft.item.ItemStack;

/**
 * @author Jared
 */
public class SetStackSizeAction implements IUndoableAction {
    
    private final ItemStack stack;
    private final int size;
    private final int oldSize;
    
    public SetStackSizeAction(ItemStack stack, int size) {
        this.stack = stack;
        this.size = size;
        this.oldSize = stack.func_77976_d();
    }
    
    private static void set(ItemStack stack, int size) {
        if(!stack.func_190926_b())
            stack.func_77973_b().func_77625_d(size);
    }
    
    @Override
    public void apply() {
        set(stack, size);
    }
    
    @Override
    public boolean canUndo() {
        return true;
    }
    
    @Override
    public void undo() {
        set(stack, oldSize);
    }
    
    @Override
    public String describe() {
        return "Setting max stack size of  " + stack.func_82833_r() + " to " + size;
    }
    
    @Override
    public String describeUndo() {
        return "Reverting max stack size of " + stack.func_82833_r() + " to " + oldSize;
    }
    
    @Override
    public Object getOverrideKey() {
        return null;
    }
}
